#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <gtk/gtk.h>
#include <gdk/gdkkeysyms.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"
#include "process.h"
#include "definition.h"

void
on_window1_destroy                     (GtkObject       *object,
                                        gpointer         user_data)
{
  gtk_exit(1);
}

void
on_button1_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
  gtk_exit(1);
}

void
on_button2_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
  GtkWidget *Window;                              /* main window     */
  GtkWidget *gtkwServer, *gtkwPort, *gtkwSearch;  /* input from user */
  GtkWidget *gtkwDisplay;                         /* display         */
  GtkTextBuffer *DisplayBuffer;                   /* display buffer  */
  char *Server, *Port, *Search;
  char Display[MAXBUFSIZE];
	
  /* find all the widgets */
  Window = gtk_widget_get_toplevel(GTK_WIDGET(button));
  gtkwServer = lookup_widget(Window,"entry1");
  gtkwPort = lookup_widget(Window,"entry2");
  gtkwSearch = lookup_widget(Window,"entry3");
  gtkwDisplay = lookup_widget(Window,"textview1");
  
  Server = (char*) gtk_entry_get_text((GtkEntry*) gtkwServer);
  Port = (char*) gtk_entry_get_text((GtkEntry*) gtkwPort);
  Search = (char*) gtk_entry_get_text((GtkEntry*) gtkwSearch);
  DisplayBuffer = gtk_text_buffer_new(NULL);
  
  if (CheckSanity(Server, Port, Search) == -1)
  {
    strcpy(Display,"Sanity check is failed\nServer, Port and Search query is required");
    gtk_text_buffer_set_text(DisplayBuffer,(gchar*)Display, strlen(Display));
    gtk_text_view_set_buffer((GtkTextView*) gtkwDisplay, DisplayBuffer);
    return;
  }
  sprintf(Display,"Connecting to %s on port %s\n",Server,Port);
  
  SearchAnime(Server, atoi(Port), Display, Search);
  gtk_text_buffer_set_text(DisplayBuffer,(gchar*)Display, strlen(Display));
  gtk_text_view_set_buffer((GtkTextView*) gtkwDisplay, DisplayBuffer);
}


gboolean
on_entry3_key_release_event            (GtkWidget       *widget,
                                        GdkEventKey     *event,
                                        gpointer         user_data)
{
  /* some people might press ENTER instead of clicking button */
  if (event->keyval  == GDK_Return)
  {
    /* too lazy to rewrite code, just hook it up with codes when button is pressed */
    GtkWidget *Window, *Button;
    Window = gtk_widget_get_toplevel(GTK_WIDGET(widget));
    Button = lookup_widget(Window,"button2");
    on_button2_clicked((GtkButton*)Button,NULL);
  }
  
  return FALSE;
}


void
on_window1_realize                     (GtkWidget       *widget,
                                        gpointer         user_data)
{
  /* naturally people are lazy...
   * so i think reading server and port config from a file is the easiest
   * way to save users from having to type them in every time
   * -> will read value of server then value of port from file called 
   *    'configuration.txt' if the file is exists in the same directory as the 
   *    program
   */
	
  FILE *fp;
  GtkWidget *gtkwServer, *gtkwPort;  /* server and port widget    */
  char Server[100], Port[10];        /* buffer to read from file  */
	
  /* find server and port widgets */
  gtkwServer = lookup_widget(widget,"entry1");
  gtkwPort = lookup_widget(widget,"entry2");

  /* read from 'configuration.txt' */
  fp = fopen("configuration.txt","r");
  if (fp == NULL) return;
  fscanf(fp,"%s",Server);           /* read server value    */
  fscanf(fp,"%s",Port);             /* then read port value */
  fclose(fp);

  if (strlen(Server) != 0 && strlen(Port) != 0)
  {
    gtk_entry_set_text((GtkEntry*)gtkwServer,(gchar*)Server);
    gtk_entry_set_text((GtkEntry*)gtkwPort,(gchar*)Port);
  }
}
